#define APPV_DATE "Tue Feb 26 16:00:00 CEST ABCD 2008"
#define APPV_MAJOR 0
#define APPV_MINOR 9
#define APPV_REVISION 001

#include "StdAfx.h"

/**	\file rpcservLinux.cpp
	\brief Implements main() function and startup of the TINE server on Linux.

  	This is a changed version of the main TINE server startup file for Linux. It contains main() function which will
	start up the TINE server. Grabber specific initialisation is done inside the TINE server initialization.

	\sa tine_server.cpp
    \author Stefan Weisse / DESY 
    \author Philip Duval / DESY (initial file)
	\date   2008
*/


void PostSystemInit(void);
void PreSystemInit(void);

extern void DoLog(const char *aFormat, ... );
extern void QuitCleanupFunction(int exitcode);

extern "C" {
TINE_EXPORT void SetClientBurstLimit(int limit);
}


int main(int argc, char *argv[])
{
	int cc;

	MAKE_COMPILER_HAPPY(argc);
	MAKE_COMPILER_HAPPY(argv);

	AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
	
	//StartupDebug = 0;
	
	SetClientBurstLimit(21000);

	SetBurstLimit(1000); // 500
	SetCycleDelay(0); // 0

	PreSystemInit();
  
	/* init RPC server: */
	if ((cc=SystemInit(TRUE)) != 0) { printf("init error: %s\n",erlst[cc]); exit(1); }

	/* call FEC specific initialization: */
	PostSystemInit();
  
	for (;;)
	{
		SystemCycle(TRUE);
	}

	haltServer();
	return 0;
}
