#include "StdAfx.h"

/** \file stringfunc.cpp
	
	\brief Implements basic string handling as declared in stringfunc.h.

	\sa stringfunc.h
	\sa IniEx.h
    \author Stefan Weisse / DESY 
	\date   2008
*/

void SetAtInternal( char **stringarray, int index, const char *value, int checkbounds);


void SetAt( char **stringarray, int index, const char *value)
{
  SetAtInternal( stringarray, index, value, 1);
}


// SW! July 06, 2007
// found out that it does not work properly for empty value

void SetAtInternal( char **stringarray, int index, const char *value, int checkbounds)
{
	assert(stringarray != NULL);
	assert(*stringarray != NULL);
	assert(value != NULL);

	char *bytearray = (char *) *stringarray;

	//BOOL inserted = TRUE;

	// get WHOLE len from stringarray
	char *tempstrarray = *stringarray;
	int len=0,len1,num=0;

	for(;;)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		len += (len1 + 1);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	len++;

	int lennew = len + 1;

	if (checkbounds != 0) if (index >= num && (index != 0)) return; 

	// seek through whole stringarray

	num = 0;
	int postorepl=0, lentorepl=0;
    
	tempstrarray = *stringarray;
	
	for(;;)
	{
		if (num == index) { postorepl = (int) (tempstrarray - *stringarray); lentorepl = strlen(tempstrarray)+1; }
		
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
		
    }

	lennew -= lentorepl;
	lennew += strlen(value)+1;

	*stringarray = (char *) new char[lennew];
	memset(*stringarray, 0, lennew);

	memcpy(*stringarray, bytearray, postorepl);

	memcpy(*stringarray + postorepl, value, strlen(value)+1 );

	memcpy(*stringarray + postorepl + strlen(value)+1, bytearray+postorepl+lentorepl, (len-postorepl)-lentorepl );

	//(*stringarray)[len + strlen(string)] = 0; // SW!
	//(*stringarray)[len + strlen(string)-1] = 0; // SW!

	delete [] bytearray;
}

// SW! July 06, 2007
// found out that it does not work properly for empty value
void SetAtGrow( char **stringarray, int index, const char *value)
{
	assert(stringarray != NULL);
	assert(*stringarray != NULL);
	assert(value != NULL);

	char *bytearray = (char *) *stringarray;

	//BOOL inserted = TRUE;

	// get WHOLE len from stringarray
	char *tempstrarray = *stringarray;

	int len=0,len1,num=0;

	for(;;)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		len += (len1 + 1);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	len++;
	
	if (len == 1) len = 0;

	int lennew = len + 1;
	int newnum = num;

	if (index >= num) 
	{
		newnum = index+1; 

		// seek through whole stringarray
		lennew = lennew + (newnum-num) + 1;

		*stringarray = (char *) new char[lennew];
		memset( *stringarray, 0, lennew);

		if (len >= 1) memcpy(*stringarray, bytearray, len);
	
		delete [] bytearray;
	}

	SetAtInternal(stringarray, index, value, 0);
}



bool RemoveAt(char **stringarray, int index)
{
	assert(stringarray != NULL);
	assert(*stringarray != NULL);

	char *bytearray = (char *) *stringarray;

	//BOOL inserted = TRUE;

	// get WHOLE len from stringarray
	char *tempstrarray = *stringarray;
	int len=0,len1,num=0;

	for(;;)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		len += (len1 + 1);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	len++;

	int lennew = len + 1;

	if (index >= num) return false; 

	// seek through whole stringarray

	num = 0;
	int postodel=0, lentodel=0;
    
	tempstrarray = *stringarray;
	
	for(;;)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		if (num == index) { postodel = (int) (tempstrarray - *stringarray); lentodel = strlen(tempstrarray)+1; }

		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
    }

	lennew -= lentodel;

	*stringarray = (char *) new char[lennew];
	memset(*stringarray, 0, lennew);

	memcpy(*stringarray, bytearray, postodel);

	memcpy(*stringarray + (len-postodel), bytearray+postodel+lentodel, (len-postodel)-lentodel );

	//(*stringarray)[len + strlen(string)] = 0; // SW!
	//(*stringarray)[len + strlen(string)-1] = 0; // SW!

	delete [] bytearray;

	return true;
}


// SW! July 06, 2007
// found out that it does not work properly for empty value
bool Add( char **stringarray, const char *string )
{
	assert(stringarray != NULL);
	assert(*stringarray != NULL);
	assert(string != NULL);

	char *bytearray = (char *) *stringarray;

	bool inserted = true;

	// get WHOLE len from stringarray
	char *tempstrarray = *stringarray;
	int len=0,len1,num=0;

	for(;;)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		len += (len1 + 1);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	len++;

	int lennew = len + strlen(string) + 1;

	// seek through whole stringarray

    tempstrarray = *stringarray;
	for(;;)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		//if (strcmp(string, tempstrarray) == 0)
		//{
		//	inserted = FALSE;
		//	return inserted;
		//}
		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
    }

	*stringarray = (char *) new char[lennew];
	memset(*stringarray, 0, lennew);

	memcpy(*stringarray, bytearray, len);

	memcpy(*stringarray + len - 1, string, strlen(string) );

	(*stringarray)[len + strlen(string)] = 0;
	(*stringarray)[len + strlen(string)-1] = 0;

	delete [] bytearray;

	inserted = true;
	return inserted;
}




// 0 for failure
int GetUpperBound( const char *stringarray )
{
	assert( stringarray != NULL);
	return( GetSize(stringarray) - 1 );
}


int GetSize( const char *stringarray )
{
	assert( stringarray != NULL);

	// get WHOLE len from stringarray
	char *tempstrarray = (char *) stringarray;
	
	int len1,num=0;

	for(;;)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
	}
    
	return( num );
}

// SW! July 06, 2007
// found out that it does not work properly for empty value
// gives reference ! or NULL if not found!
char *GetAt( const char *stringarray, int index)
{
	assert( stringarray != NULL);

	char *tempstrarray = (char *) stringarray;
	
	int len1,num=0;

	for(;;)
	{
		if (num == 0)
		{
			if ((tempstrarray[0] == 0) && (tempstrarray[1] == 0)) break;
		}
		else if ((tempstrarray[0] == 0) && (tempstrarray[-1] == 0)) break;

		if (num == index) return( tempstrarray );

		len1 = strlen(tempstrarray);
		tempstrarray += (len1 + 1);
		num++;
	}

    return( NULL );
}

void copywholestring(char *dest, const char *src)
{
	assert( dest != NULL);
	assert( src != NULL);

	strncpy(dest, src, strlen(src)+1 );
}

int find( const char *str, const char *search)
{
	assert( str != NULL);
	assert( search != NULL);

	const char *res = strstr(str, search);

	if ((res == NULL) || (res == str)) 
		return( -1 );
	else
		return( (int) (res-str));
}


int reversefind( const char *str, int c )
{
	assert( str != NULL);

	const char *res = strrchr(str, c);

	if (res == NULL) 
		return( -1 );
	else
		return( (int) (res-str));
}

int DeleteString( char *string, int nIndex, int nCount)
{
	assert( string != NULL);

	int len = strlen(string);
 
	if (nIndex < len)
	{
		if ((nIndex + nCount)>len ) nCount = (nIndex + nCount) - len + 1;

		int amount = len-(nIndex+nCount);
		char *dest = &string[nIndex];
		const char *src = &string[nIndex+nCount];

		if (amount > 0) memcpy(dest, src, amount); // SW! Feb 26, 2007 safety check added amount>0
	}

	return( strlen( string ) );
}


void Left(char *dest, const char *src, int num)
{
	assert( dest != NULL);
	assert( src != NULL);

	strncpy(dest, src, num);
	dest[num] = 0;
}

void Mid( char *dest, const char *src, int left, int count)
{
	assert( dest != NULL);
	assert( src != NULL);

	strncpy(dest, &src[left], count);
	dest[count]=0;
}

void Mid( char *dest, const char *src, int left)
{
	assert( dest != NULL);
	assert( src != NULL);

	strncpy(dest, &src[left], strlen(src)-left);
	dest[strlen(src)-left]=0;
}

void Right( char *dest, const char *src, int num)
{
	assert( dest != NULL);
	assert( src != NULL);

	strncpy(dest, &src[strlen(src)-num], num);
	dest[num] = 0;
}


bool isLeftmostChar(const char *str, int c)
{
	assert( str != NULL);

	if (str[0] == (char) c) return true;

	return false;
}

bool isRightmostChar( const char *str, int c)
{
	assert( str != NULL);

	int len = strlen(str);

	if (len >= 1)
	{
		if (str[len-1] == (char) c) return true;
	}

	return false;
}


void addstr( char *dest, const char *add)
{
	assert( dest != NULL);
	assert( add != NULL);

	strcat(dest, add);
}

int IsEmpty( char *str )
{
	assert( str != NULL);

	if (strlen(str) == 0) 
		return( 1 ); 
	else 
		return( 0 );
}

int ReadStringInt(FILE *fp, char *line)
{
	assert( fp != NULL);
	assert( line != NULL);
	
	*line = 0;
	
	char *ret=fgets(line, MAX_STRING_LENGTH, fp);
	if (ret == NULL) 
	{ 
		if (feof(fp) != 0) return( 0 );
		if (ferror(fp) != 0) return( -1 );
	}
	return( strlen(line) );
}

bool ReadString(FILE *fp, char *line)
{
	assert( fp != NULL);
	assert( line != NULL);

	int r = ReadStringInt(fp, line);
	if (r>0) return true;

	return false;
}

void TrimRight(char *line, char *defaultset)
{
	assert( line != NULL );
	assert( defaultset != NULL );

	int length = strlen(line);
	if (length == 0) return;

	while( length>0 ) //SW! Feb 26, 2008 bug removed; was: length>=0
	{
		{
		unsigned int i;
		for (i=0;i<strlen(defaultset);i++)
		{
			if (line[length-1] == defaultset[i]) { line[length-1] = 0; break; }
		}
		if (i == strlen(defaultset)) break;

		length--;
		}
	}
}
