package de.desy.tine.definitions;

/**
 * @brief tine Static error strings
 */
public class TErrorList
{
  public static final short CE_SENDDATA = 0x4000;
  public static final short CE_RENEGOTIATE = 0x2000;
  public static final int ERROR_SIZE = 32;
  public static final short success = 0;
  public static final short illegal_line = 1;
  public static final short illegal_format = 2;
  public static final short illegal_arithmetic = 3;
  public static final short ambiguous = 4;
  public static final short illegal_delimiter = 5;
  public static final short zero_divide = 6;
  public static final short WA_full = 7;
  public static final short non_existent = 8;
  public static final short invalid_transport = 9;
  public static final short link_exhausted = 10;
  public static final short not_properly = 11;
  public static final short un_allocated = 12;
  public static final short no_such_line = 13;
  public static final short illegal_data_size = 14;
  public static final short io_error = 15;
  public static final short illegal_context = 16;
  public static final short runtime_error = 17;
  public static final short system_error = 18;
  public static final short hardware_busy = 19;
  public static final short argument_list_error = 20;
  public static final short invalid_parameter = 20;
  public static final short file_error = 21;
  public static final short use_stream_transport = 22;
  public static final short dimension_error = 23;
  public static final short square_root_negative = 24;
  public static final short buffer_too_small = 25;
  public static final short string_too_long = 26;
  public static final short ipx_socket_error = 27;
  public static final short net_read_error = 28;
  public static final short not_ready = 29;
  public static final short invalid_transport_size = 30;
  public static final short log_negative = 31; /* or = 0 */
  public static final short device_not_connected = 32;
  public static final short unauthorised_action = 33;
  public static final short hardware_error = 34;
  public static final short illegal_equipment_number = 35;
  public static final short illegal_device_number = 35;
  public static final short illegal_device = 35;
  public static final short illegal_property = 36;
  public static final short out_of_range = 37;
  public static final short not_implemented = 38;
  public static final short no_such_computer = 39;
  public static final short struct_sealed = 40;
  public static final short syntax_error = 41;
  public static final short no_such_file = 42;
  public static final short file_already_exists = 43;
  public static final short no_file_space = 44;
  public static final short link_not_open = 45;
  public static final short remitted_data_lost = 46;
  public static final short end_of_file = 47;
  public static final short archive_busy = 48;
  public static final short server_name_in_use = 49;
  public static final short no_such_column = 50;
  public static final short out_of_client_memory = 51;
  public static final short def_area_full = 52;
  public static final short address_unresolved = 53;
  public static final short invalid_property = 54;
  public static final short address_unknown = 55;
  public static final short name_unknown = 56;
  public static final short invalid_keyword = 57; 
  public static final short invalid_link = 58; 
  public static final short string_expected = 59;
  public static final short out_of_local_memory = 60;
  public static final short out_of_shared_memory = 61;
  public static final short invalid_structure_tag = 62;
  public static final short invalid_index = 63;
  public static final short illegal_equipment_name = 64;
  public static final short link_error = 65;
  public static final short code_failure = 66;
  public static final short non_existent_server = 67;
  public static final short deprecated = 68;
  public static final short not_supported = 69;
  public static final short illegal_character = 70;
  public static final short illegal_operator = 71;
  public static final short not_allowed = 72;
  public static final short illegal_read_write = 73;
  public static final short out_of_server_memory = 74;
  public static final short database_not_loaded = 75;
  public static final short illegal_command = 76;
  public static final short resources_exhausted = 77;
  public static final short file_not_open = 78;
  public static final short sedac_error = 79; /* sedac */
  public static final short no_such_loop = 80; /* serial sedac */
  public static final short semaphore_error = 81;
  public static final short driver_not_installed = 82;
  public static final short port_not_available = 83;
  public static final short scan_error = 84; /* scanner */
  public static final short semaphore_busy = 85;
  public static final short non_existent_elem = 86;
  public static final short non_existent_fec = 87;
  public static final short non_existent_client = 88;
  public static final short cannot_lock = 89;
  public static final short not_running = 90;
  public static final short not_posted = 91;
  public static final short not_accepted = 92;
  public static final short operation_timeout = 93;
  public static final short illegal_protocol = 94;
  public static final short gpib_error = 95;
  public static final short rs232_error = 96;
  public static final short operation_busy = 97;
  public static final short connection_timeout = 98;
  public static final short illegal_mode = 99;
  public static final short not_owner = 100;
  public static final short not_defined = 101;
  public static final short net_write_error = 102;
  public static final short invalid_data = 103;
  public static final short software_error = 104;
  public static final short access_denied = 105;
  public static final short tcp_not_supported = 106;
  public static final short ipx_not_supported = 107;
  public static final short host_not_resolved = 108;
  public static final short tcp_connect_error = 109;
  public static final short tcp_socket_error = 110;
  public static final short configuration_error = 111;
  public static final short invalid_return_code = 112;
  public static final short link_blacklisted = 113;
  public static final short link_exists = 114;
  public static final short max_alarms_exceeded = 115;
  public static final short not_exported = 116;
  public static final short is_switching = 117;
  public static final short at_limit = 118;
  public static final short get_subscription_id = 119;
  public static final short renegotiate_contract = 120;
  public static final short server_redirection = 121;
  public static final short value_too_high = 122;
  public static final short value_too_low = 123;
  public static final short warn_too_high = 124;
  public static final short warn_too_low = 125;
  public static final short completion_waiting = 126;
  public static final short cannot_select = 127;
  public static final short has_query_function = 128;
  public static final short not_signalled = 129;
  public static final short call_redirection = 130;
  public static final short udp_socket_error = 131;
  public static final short mutex_error = 132;
  public static final short data_not_local = 133;
  public static final short name_already_exists = 134;
  public static final short already_assigned = 135;
  public static final short invalid_field = 136;
  public static final short mcast_init_error = 137;
  public static final short invalid_mcast_group = 138;
  public static final short non_existent_function = 139;
  public static final short property_is_mca = 140;
  public static final short invalid_name = 141;
  public static final short invalid_value = 142;
  public static final short device_error = 143;
  public static final short device_not_ready = 144;
  public static final short device_busy = 145;
  public static final short invalid_interval = 146;
  public static final short notification_pending = 147;
  public static final short thread_error = 148;
  public static final short is_terminating = 149;
  public static final short name_server_unknown = 150;
  public static final short lock_required = 151; 
  public static final short not_initialized = 152; 
  public static final short invalid_structure_size = 153; 
  public static final short canbus_error = 154; 
  public static final short profibus_error = 155; 
  public static final short data_stale = 156;
  public static final short has_bitfield_tag = 157;
  public static final short has_structure_tag = 157;
  public static final short not_locked = 158;
  public static final short lock_expired = 159;
  public static final short not_registered = 160;
  public static final short non_existent_property = 161;
  public static final short memory_overwrite = 162;
  public static final short server_idle = 163;
  public static final short not_applicable = 164;
  public static String[] errorString = {"success", "illegal line number", "illegal format specification",
      "illegal arithmetic expression", "ambiguous command", "illegal delimiter", "attempt to divide by zero",
      "working area full", "nonexistent name", "invalid transport medium", "resources exhausted",
      "command not properly terminated", "not allocated", "nonexistent line addressed", "illegal data size",
      "i/o error", "illegal context", "runtime error", "system error",
      "hardware operation in progress", "parameter error", "file error", "resort to stream transport",
      "array dimension error", "square root of neg.number", "data buffer too small", "string too long",
      "ipx socket error", "net read error", "call not ready", "invalid transport size",
      "logarithm argument <= 0", "device not connected", "unauthorised action", "hardware error",
      "illegal device", "illegal property", "value out of range", "not implemented yet",
      "no such computer", "tagged struct is sealed", "syntax error", "no such file", "file already exists",
      "no file space", "link timeout", "remitted data lost", "end of file", "archive in progress",
      "server name in use", "no such column", "out of client memory", "Defined function area full",
      "address unresolved", "invalid or missing property", "address unknown",
      "name unknown", "invalid keyword", "invalid link handle", "String expected",
      "out of local memory", "out of shared memory", "invalid structure tag", "invalid index",
      "illegal equipment name", "link error", "code failure", "nonexistent server",
      "deprecated", "not supported", "illegal character", "illegal relational operator",
      "not allowed", "illegal read/write attempted", "out of server memory",
      "database not loaded", "illegal command", "resources exhausted", "file not open", "SEDAC error",
      "no serial SEDAC loop", "semaphore error", "driver not installed", "COMx port_not_available",
      "scanner error", "semaphore blocked", "nonexistent Element", "nonexistent Fec", "nonexistent Client",
      "unable to lock memory", "server not responding", "command not posted", "command not accepted",
      "operation timeout", "Illegal network protocol", "gpib error", "rs232 error", "operation busy",
      "connection timeout", "illegal mode", "not owner", "not defined", "net write error", "invalid data",
      "software error", "access denied", "tcp not supported", "ipx not supported", "tcp host not resolved",
      "tcp connect error", "tcp socket error", "configuration error", "invalid return code", "link is blacklisted", "link exists",
      "alarms buffer full", "not exported", "is switching", "at limit", "get subscription id",
      "renegotiate contract", "server redirection", "value too high", "value too low", "warn too high",
      "warn too low", "wait for completion", "cannot select", "has query function", "not signalled",
      "call redirection", "udp socket error", "mutex error", "data not local", "name already exists",
      "already assigned", "invalid field", "multicast init error", "invalid multicast group",
      "nonexistent function", "prop is channel array", "invalid name", "invalid value", "device_error",
      "device not ready", "device busy", "invalid time interval", "notification pending", "thread error",
      "process is terminating", "name server unknown", "access lock required", "not initialized", 
      "invalid structure size","canbus error","profibus error","data stale","has structure tag",
      "not locked","lock expired","not registered","nonexistent property","memory overwrite",
      "server idle","not applicable"
};
  public TErrorList()
  {
    super();
  }
  /**
   * @brief Interprets system error code as string
   * @param code
   *          is the tine error code for which the error string is desired
   */
  public static String getErrorString(int code)
  {
    if (code == -1)return new String("link status not available (link pending)");
    code &= 0x0fff;
    if (code >= 0 && code < errorString.length)
      return errorString[code].trim();
    else
      return new String("Error " + code + " undefined");
  }
  /**
   * @brief Interprets system error code as string
   * @param code
   *          is the tine error code for which the error string is desired
   */
  public static String toString(int code)
  {
    return getErrorString(code);
  }
}
