package de.desy.tine.histUtils;

import de.desy.tine.structUtils.TTaggedStructure;

public class HstCfg extends TTaggedStructure
{
  public void clear()
  {
    contextString = null;
    serverString = null;
    deviceString = null;
    propertyString = null;
    unitsString = null;
    descriptionString = null;
  }
  private char[] context = new char[32];
  private String contextString;
  private char[] server = new char[32];
  private String serverString;
  private char[] device = new char[64];
  private String deviceString;
  private char[] property = new char[64];
  private String propertyString;
  private char[] units = new char[16];
  private String unitsString;
  private char[] description = new char[64];
  private String descriptionString;
  private int index[] = new int[1];
  private int subIndex[] = new int[1];
  private float scale[] = new float[1];
  private float offset[] = new float[1];
  private float max[] = new float[1];
  private float min[] = new float[1];
  private int plot[] = new int[1];
  private void initStructure()
  {
    addField(context,"context");
    addField(server,"server");
    addField(device,"device");
    addField(property,"property");
    addField(units,"units");
    addField(description,"description");
    addField(index,"index");
    addField(subIndex,"subIndex");
    addField(scale,"scale");
    addField(offset,"offset");
    addField(max,"max");
    addField(min,"min");
    addField(plot,"plot");
    initDone();    
  }
  HstCfg()
  {
    super();
    initStructure();
  }
  HstCfg(HstCfg reference)
  {
    super();
    initStructure();
    System.arraycopy(reference.context, 0, context, 0, 32);    
    System.arraycopy(reference.server, 0, server, 0, 32);    
    System.arraycopy(reference.device, 0, device, 0, 64);    
    System.arraycopy(reference.property, 0, property, 0, 64);    
    System.arraycopy(reference.units, 0, units, 0, 16);    
    System.arraycopy(reference.description, 0, description, 0, 64);
    index[0] = reference.index[0];
    subIndex[0] = reference.subIndex[0];
    scale[0] = reference.scale[0];
    offset[0] = reference.offset[0];
    max[0] = reference.max[0];
    min[0] = reference.min[0];
    plot[0] = reference.plot[0];
  }
  public String getContext()
  {
    if (contextString == null) contextString = new String(context).trim();
    return contextString;
  }
  public String getDescription()
  {
    if (descriptionString == null) descriptionString = new String(description).trim();
    return descriptionString;
  }
  public String getDevice()
  {
    if (deviceString == null) deviceString = new String(device).trim();
    return deviceString;
  }
  public int getIndex()
  {
    return index[0];
  }
  public float getMax()
  {
    return max[0];
  }
  public float getMin()
  {
    return min[0];
  }
  public float getOffset()
  {
    return offset[0];
  }
  public int getPlot()
  {
    return plot[0];
  }
  public String getProperty()
  {
    if (propertyString == null) propertyString = new String(property).trim();
    return propertyString;
  }
  public float getScale()
  {
    return scale[0];
  }
  public String getServer()
  {
    if (serverString == null) serverString = new String(server).trim();
    return serverString;
  }
  public int getSubIndex()
  {
    return subIndex[0];
  }
  public String getUnits()
  {
    if (unitsString == null) unitsString = new String(units).trim();
    return unitsString;
  }
}
