/*
 * Created on Feb 6, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.io;

import java.io.*;
import java.net.*;

import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

public class TBucket
{
  Socket sck; // TCP connection socket
  public Socket getSocket() { return sck; }
  public void setSocket(Socket socket) { sck = socket; }
  int ptr; // bucket pointer
  public int getBucketPointer() { return ptr; }
  public void setBucketPointer(int pointer) { ptr = pointer; }
  private int siz; // bucket target size
  private int capacity = TPacket.MAX_DATAGRAM_SIZE;
  public int getBucketSize() { return siz; }
  public void setBucketSize(int bucketSize) { siz = bucketSize; }
  private byte[] buf = null; // bucket buffer
  public byte[] getBucketBuffer() { return buf; }
  int port;
  public int getBucketPort() { return port; }
  public void setBucketPort(int portAddr) { port = portAddr; }
  InetAddress iaddr;
  public InetAddress getBucketEndpoint() { return iaddr; }
  public void setBucketEndpoint(InetAddress inetAddr) { iaddr = inetAddr; }
  public boolean active = false;
  public boolean isDeactivating = false;
  int number;
  private Thread bckThrd;
  OutputStream os;
  InputStream is;
  public Thread getBucketThread() { return bckThrd; }
  public void setBucketThread(Thread thread) { bckThrd = thread; } 
  public InputStream getInputStream() { return is; }
  public void setInputStream(InputStream input) { is = input; }
  public OutputStream getOutputStream() { return os; }
  public void setOutputStream(OutputStream output) { os = output; }
  public void setCapacity(int newBufferSize)
  {
    byte[] b=null;
    try
    {
      b = new byte[newBufferSize];
    }
    catch (OutOfMemoryError e)
    {
      MsgLog.log("TBucket.setCapacity", "not enough memory to allocate "+newBufferSize+" bytes",TErrorList.out_of_local_memory,e,0);
      return;
    }
    buf = b;
    capacity = newBufferSize;
  }
  public int getCapacity() { return capacity; }
  protected void initBucket(Socket socket,Thread thread,int capacity)
  {
    sck = socket;
    try
    {
      os = socket.getOutputStream();  
      is = socket.getInputStream(); 
      iaddr = socket.getInetAddress();
      port = socket.getPort();
      bckThrd = thread;
      this.capacity = capacity;
      buf = new byte[capacity];
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }    
  }
  public TBucket() 
  { 
  }
  protected void initBucket(InetAddress inetAddr,int portAddr,Thread thread,int capacity)
  {
    try
    {
      sck = new Socket(inetAddr,portAddr);
      os = sck.getOutputStream();  
      is = sck.getInputStream(); 
      iaddr = inetAddr;
      port = portAddr;
      bckThrd = thread;
      this.capacity = capacity;
      buf = new byte[capacity];
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }    
  }
  public void activate()
  {
    if (bckThrd != null) bckThrd.start(); 
  }
}
