/*
 * Created on Nov 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.io;
//import java.io.*;
import java.net.*;
import de.desy.tine.startup.TInitializer;
import de.desy.tine.startup.TInitializerFactory;

/**
 * \internal
 * TODO: This now appears to work -> just use a single MulticastSocket called 's'
 * 
 * @author duval
 *
 */
public class TPacket
{
  private static final int defaultRcvBufSiz = 0x10000;
  private static final int defaultTtl = 16;
  public static final int MAX_DATAGRAM_SIZE = 64000;
  private TInitializer initializer=TInitializerFactory.getInstance().getInitializer();
  private MulticastSocket s;
  public MulticastSocket getSocket() { return s; }
  //public DatagramSocket s;
  //public MulticastSocket m;
  InetAddress hostAddress;
  private boolean isMCastListener = false;
  public boolean isMulticastListener() { return isMCastListener; }
  //byte[] bufOut = new byte[1472];
  public DatagramPacket dpOut;
  byte[] bufIn = new byte[MAX_DATAGRAM_SIZE];
  public DatagramPacket dpIn = new DatagramPacket(bufIn, bufIn.length);
  public TPacket()
  {
    this(defaultRcvBufSiz,defaultTtl);
  }
  public TPacket(int rcvBufferSize, int timeToLive)
  {
    boolean socketBound = false;
    int port = initializer.getClnPort();
    for (int i=0; !socketBound && i<1000; i++)
    {
      try
      {
        InetSocketAddress addr = new InetSocketAddress(port+i);
        s = new MulticastSocket(null);
        s.setReuseAddress(false);
        s.bind(addr);
        s.setSoTimeout(0);
        s.setReceiveBufferSize(rcvBufferSize);
        s.setTimeToLive(timeToLive);
        socketBound = true;
      }
      catch (SocketException e)
      {
        if (i == 999)
        {
          System.err.println("Can't open socket");
          e.printStackTrace();
        }
      }
      catch (Exception e)
      {
        e.printStackTrace();
      }
    }
  }
  public TPacket(int port)
  {
    this(port,defaultRcvBufSiz,defaultTtl);
  }
  public TPacket(int port,int rcvBufferSize,int timeToLive)
  {
    int clnport = initializer.getClnPort();
    boolean useNextPort = false;
    boolean socketBound = false;
    InetAddress grp;
    for (int i=0; !socketBound && i<1000; i++)
    {
      try
      {
        if (port == 0) 
        { // general client side port
          useNextPort = true;
          InetSocketAddress addr = new InetSocketAddress(clnport+i);
          s = new MulticastSocket(null);
          s.setReuseAddress(false);
          s.bind(addr);
          s.setSoTimeout(0);
          s.setReceiveBufferSize(rcvBufferSize);
          s.setTimeToLive(timeToLive);
          socketBound = true;
        } 
        else if (port == initializer.getGCastPort()) 
        { // globals listening port
          grp = InetAddress.getByName(initializer.getGCastAddress());
          s = new MulticastSocket(port);
          s.joinGroup(grp); // this is the canonical globals multicast group
          s.setSoTimeout(0);
          s.setTimeToLive(timeToLive);
          socketBound = true;
          isMCastListener = true;
        } 
        else if (port == initializer.getMCastPort()) 
        { // general multi-cast listening port
          grp = InetAddress.getByName(initializer.getMCastAddress());
          s = new MulticastSocket(port);
          s.joinGroup(grp); // this is the canonical server multicast group
          s.setSoTimeout(0);
          s.setReceiveBufferSize(rcvBufferSize);
          s.setTimeToLive(timeToLive);
          socketBound = true;
          isMCastListener = true;
        } 
        else if (port == initializer.getNetCastPort()) 
        { // server port for responding to services request
          grp = InetAddress.getByName(initializer.getNetCastAddress());
          s = new MulticastSocket(port);
          s.joinGroup(grp);
          s.setSoTimeout(0);
          s.setReceiveBufferSize(rcvBufferSize);
          socketBound = true;
          isMCastListener = true;
        } 
        else 
        { // server's listening port
          InetSocketAddress addr = new InetSocketAddress(port);
          s = new MulticastSocket(null);
          s.setReuseAddress(false);
          s.bind(addr);
          s.setSoTimeout(0);
          s.setReceiveBufferSize(rcvBufferSize);
          s.setTimeToLive(timeToLive);
          socketBound = true;
        }
      }
      catch (Exception e)
      {
        if (!useNextPort)
        {
          System.err.println("Can't open socket");
          e.printStackTrace();
        }
      }
    }
  }
}
