package de.desy.tine.server.logger;

import java.util.ArrayList;
import de.desy.tine.client.TLinkFactory;

public class MsgLog
{
  public class MsgEntry
  {
    private long time;
    private int code;
    private String msg;
    private Throwable e;
    MsgEntry(long t, String m) { time = t; msg = m; code = 0;}
    MsgEntry(long t, String m, int c, Throwable x) { time = t; msg = m; code = c; e = x; }
    public int getCode() { return code; }
    public String getMsg() { return msg; }
    public long getTime() { return time; }
    public Throwable getExecption() { return e; }
  }
  private static final int MAX_NUM_MESSAGES = 512;
  private static MsgEntry[] msgs = new MsgEntry[MAX_NUM_MESSAGES];
  private static int msgptr = 0;
  private MsgLog()
  {
    msgs[0] = new MsgEntry(System.currentTimeMillis(),"Message Log started");
  }
  private static MsgLog instance = new MsgLog();
  public static void log(String message,int code)
  {
    if (message == null) return;
    msgptr = (msgptr+1) % MAX_NUM_MESSAGES;
    msgs[msgptr] = instance.new MsgEntry(System.currentTimeMillis(),message,code,null);
  }
  public static void log(String source,String message,int code,Throwable exception,int debugLevel)
  {
    if (message == null) return;
    msgptr = (msgptr+1) % MAX_NUM_MESSAGES;
    msgs[msgptr] = instance.new MsgEntry(System.currentTimeMillis(),message,code,exception);
    if (TLinkFactory.debugLevel >= debugLevel) DbgLog.log(source,message);
  }
  public static MsgEntry[] getMessages(long starttime)
  {
    int i=msgptr,n;
    ArrayList<MsgEntry> m = new ArrayList<MsgEntry>();
    for (n=0; n<MAX_NUM_MESSAGES; n++)
    { // first find the start (go backwards in time)
      i = (msgptr - n + MAX_NUM_MESSAGES) % MAX_NUM_MESSAGES;
      if (msgs[i] == null || msgs[i].time < starttime) break;
      m.add(msgs[i]);
    }
    return m.size() > 0 ? m.toArray(new MsgEntry[0]) : null;
  }
  public static MsgEntry[] getMessages(int depth)
  {
    int i=msgptr,n;
    ArrayList<MsgEntry> m = new ArrayList<MsgEntry>();
    for (n=0; n<MAX_NUM_MESSAGES && n<depth; n++)
    { // first find the start (go backwards in time)
      i = (msgptr - n + MAX_NUM_MESSAGES) % MAX_NUM_MESSAGES;
      if (msgs[i] == null) break;
      m.add(msgs[i]);
    }
    return m.size() > 0 ? m.toArray(new MsgEntry[0]) : null;
  }
}
