/*
 * Created on Dec 15, 2004
 * CHANGES 
 * 2005-02-15 JW Made non-static
 */
package de.desy.tine.server.properties;
import java.util.*;

// TODO Is ID needed at all?
// TODO If not, can this class be replaced by a plain HashSet?

/**
 * \internal
 * 
 * @author duval
 *
 */
public final class TMetaProperties
{
  public final class TMetaProperty
  {
    private String tag;
    private int id;
    public String getTag() { return tag; }
    public int getId() { return id; }
    public TMetaProperty(String extension,int index)
    {
      tag = new String(extension);
      id = index;
    }
  }
  private  LinkedList<TMetaProperty> mp = new LinkedList<TMetaProperty>();
  
  public static final int EGU_ID = 1;
  public static final int HST_ID = 2;
  public static final int NAM_ID = 3;
  public static final int DSC_ID = 4;
  public static final int BIT_ID = 5;
  public static final int MSK_ID = 6;
  public static final int GAT_ID = 7;
  
  public TMetaProperties()
  {
    mp.add(new TMetaProperty(".AR",HST_ID));
    mp.add(new TMetaProperty(".ARC",HST_ID));
    mp.add(new TMetaProperty(".ARCH",HST_ID));
    mp.add(new TMetaProperty(".EGU",EGU_ID));
    mp.add(new TMetaProperty(".HST",HST_ID));
    mp.add(new TMetaProperty(".HIST",HST_ID));
    mp.add(new TMetaProperty(".HST@",HST_ID));
    mp.add(new TMetaProperty(".HIST@",HST_ID));
    mp.add(new TMetaProperty(".NAM",NAM_ID));
    mp.add(new TMetaProperty(".DSC",DSC_ID));
    mp.add(new TMetaProperty(".DESC",DSC_ID));
    mp.add(new TMetaProperty(".BIT.",BIT_ID));
    mp.add(new TMetaProperty(".MASK.",MSK_ID));
    mp.add(new TMetaProperty(".GATE.",GAT_ID));
  }
  public int getGate(String property)
  {
    int idx, bit, gate = 0;
    if ((idx=property.indexOf(".BIT.")) > 0)
    {
      bit = Integer.parseInt(property.substring(idx+5));
      gate = 0x01 << bit;
    }
    else if ((idx=property.indexOf(".MASK.")) > 0 ||
             (idx=property.indexOf(".GATE.")) > 0)
    {
      String istr = property.substring(idx+6);
      if (istr.startsWith("0x") || istr.startsWith("0X"))
        gate = Integer.parseInt(istr,16);
      else
        gate = Integer.parseInt(istr);
    }
    return gate;
  }
  public String getTargetProperty(String property)
  {
    String ext;
    int idx = 0;
    for (int i=0; i<mp.size(); i++)
    {
      ext = ((TMetaProperty)mp.get(i)).getTag();
      //if (property.endsWith(ext)) return property.substring(0,property.length()-ext.length());
      if ((idx=property.indexOf(ext)) > 0) return property.substring(0,idx);
    }
    return property;
  }
  public int getIndex(String property)
  {
    String ext;
    for (int i=0; i<mp.size(); i++)
    {
      ext = ((TMetaProperty)mp.get(i)).getTag();
      //if (property.endsWith(ext)) return ((TMetaProperty)mp.get(i)).getId();
      if (property.indexOf(ext) > 0) return ((TMetaProperty)mp.get(i)).getId();
    }
    return -1;
  }
  public boolean isMetaProperty(String property)
  {
    if (getIndex(property) < 0) return false;
    return true; 
  }
  public static boolean isHistorySnapshot(String property)
  {
    return (property.endsWith(".HIST@") || property.endsWith(".HST@"));
  }
  public static boolean isCentralArchive(String property)
  {
    return (property.endsWith(".ARCH") || 
            property.endsWith(".ARC") || 
            property.endsWith(".AR"));
  }
}
