/*
 * Created on May 7, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package de.desy.tine.types;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.endianUtils.Swap;
public final class DBLDBL implements TCompoundDataObject
{
  public double d1val;
  public double d2val;
  public double getDoubleValue() { return (double)d1val; }
  public int getIntegerValue() { return (int)d2val; }
  public static final int sizeInBytes = 16;
  public static final short dFormat = TFormat.CF_DBLDBL;
  public void setValues(double newD1Value, double newD2Value)
  {
    d1val = newD1Value; d2val = newD2Value; 
  }
  public int getSizeInBytes() { return sizeInBytes; }
  public short getFormat() { return dFormat; }    
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  public byte[] hByteArray;
  public void setByteArray(byte[] byteArray) { hByteArray = byteArray; }
  public byte[] getByteArray() { return hByteArray; }
  public DBLDBL() {d1val = 0; d2val = 0; }  
  public DBLDBL(double d) { d1val = d; d2val = d; }  
  public DBLDBL(double d1, double d2) { d1val = d1; d2val = d2;}  
  public DBLDBL(DBLDBL instance) { d1val = instance.d1val; d2val = instance.d2val; }
  
  @Override
  public String toString()
  {
      return "["+ d1val + ", " + d2val + "]";
  }
  public boolean equals(DBLDBL instance)
  {
    if (instance.d1val != d1val) return false;
    if (instance.d2val != d2val) return false;
    return true;
  }
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      byte[] b = Swap.Double(d1val);
      ds.write(b,0,8);
      b = Swap.Double(d2val);
      ds.write(b,0,8);
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }    
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      byte[] b = new byte[8];
      ds.read(b,0,8);
      d1val = Swap.Double(b);
      ds.read(b,0,8);
      d2val = Swap.Double(b);
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }  
  }
  @Override
  public int hashCode()
  {
    final int PRIME = 31;
    int result = 1;
    long temp;
    temp = Double.doubleToLongBits(d1val);
    result = PRIME * result + (int) (temp ^ (temp >>> 32));
    temp = Double.doubleToLongBits(d2val);
    result = PRIME * result + (int) (temp ^ (temp >>> 32));
    return result;
  }
  @Override
  public boolean equals(Object obj)
  {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    final DBLDBL other = (DBLDBL) obj;
    return equals(other);
  }
}