/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.desy.tine.xmlUtils;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

/**
 *
 * @author karol
 */
public class AlarmCfg extends TineConfigItem
{
    private String deviceName = new String("");
    private ValidatedInt severity = new ValidatedInt();
    private ValidatedInt severityHigh = new ValidatedInt();
    private ValidatedInt severityLow = new ValidatedInt();
    private ValidatedInt severityWarnHigh = new ValidatedInt();
    private ValidatedInt severityWarnLow = new ValidatedInt();
    private ValidatedInt system = new ValidatedInt();
    private ValidatedInt valueMask = new ValidatedInt();
    private ValidatedInt valueNormal = new ValidatedInt();
    private ValidatedInt countThreshold = new ValidatedInt();
    private ValidatedFloat valueHigh = new ValidatedFloat();
    private ValidatedFloat valueLow = new ValidatedFloat();
    private ValidatedFloat valueWarnHigh = new ValidatedFloat();
    private ValidatedFloat valueWarnLow = new ValidatedFloat();
    private ValidatedInt code = new ValidatedInt();
    private ValidatedInt codeHigh = new ValidatedInt();
    private ValidatedInt codeLow = new ValidatedInt();
    private boolean normalIsAlarm = false;
    public boolean isNormalAlarm() { return normalIsAlarm; }
    public AlarmCfg(String name)
    {
        super(name);
    }

    public ValidatedInt getCountThreshold()
    {
        return countThreshold;
    }

    public String getDeviceName()
    {
        return deviceName;
    }

    public ValidatedInt getSeverityHigh()
    {
        return severityHigh;
    }

    public ValidatedInt getSeverityLow()
    {
        return severityLow;
    }

    public ValidatedInt getSeverityWarnHigh()
    {
        return severityWarnHigh;
    }

    public ValidatedInt getSeverityWarnLow()
    {
        return severityWarnLow;
    }

    public ValidatedInt getSystem()
    {
        return system;
    }

    public ValidatedFloat getValueHigh()
    {
        return valueHigh;
    }

    public ValidatedFloat getValueLow()
    {
        return valueLow;
    }

    public ValidatedInt getValueMask()
    {
        return valueMask;
    }

    public ValidatedInt getValueNormal()
    {
        return valueNormal;
    }

    public ValidatedFloat getValueWarnHigh()
    {
        return valueWarnHigh;
    }

    public ValidatedFloat getValueWarnLow()
    {
        return valueWarnLow;
    }

    public void setCountThreshold(ValidatedInt countThreshold)
    {
        this.countThreshold = countThreshold;
    }

    public void setDeviceName(String deviceName)
    {
        this.deviceName = deviceName;
    }

    public void setSeverityHigh(ValidatedInt severityHigh)
    {
        this.severityHigh = severityHigh;
    }

    public void setSeverityLow(ValidatedInt severityLow)
    {
        this.severityLow = severityLow;
    }

    public void setSeverityWarnHigh(ValidatedInt severityWarnHigh)
    {
        this.severityWarnHigh = severityWarnHigh;
    }

    public void setSeverityWarnLow(ValidatedInt severityWarnLow)
    {
        this.severityWarnLow = severityWarnLow;
    }

    public void setSystem(ValidatedInt system)
    {
        this.system = system;
    }

    public void setValueHigh(ValidatedFloat valueHigh)
    {
        this.valueHigh = valueHigh;
    }

    public void setValueLow(ValidatedFloat valueLow)
    {
        this.valueLow = valueLow;
    }

    public void setValueMask(ValidatedInt valueMask)
    {
        this.valueMask = valueMask;
    }

    public void setValueNormal(ValidatedInt valueNormal)
    {
        this.valueNormal = valueNormal;
    }

    public void setValueWarnHigh(ValidatedFloat valueWarnHigh)
    {
        this.valueWarnHigh = valueWarnHigh;
    }

    public void setValueWarnLow(ValidatedFloat valueWarnLow)
    {
        this.valueWarnLow = valueWarnLow;
    }

    void dump(int margin)
    {
       String m = new String("");
       for( int i = 0; i < margin; i++ ) m += " ";
       
       System.out.println( m + "Device name = " + getDeviceName());
       System.out.println( m + "Severity (default) = " + getSeverity());
       System.out.println( m + "Severity high = " + getSeverityHigh());
       System.out.println( m + "Severity low = " + getSeverityLow());
       System.out.println( m + "Severity high warn = " + getSeverityWarnHigh());
       System.out.println( m + "Severity low warn = " + getSeverityWarnLow());
       System.out.println( m + "System = " + getSystem());
       System.out.println( m + "Value mask = " + getValueMask());
       System.out.println( m + "Value normal = " + getValueNormal());
       System.out.println( m + "Count threshold = " + getCountThreshold());
       System.out.println( m + "Value high = " + getValueHigh());
       System.out.println( m + "Value low = " + getValueLow());
       System.out.println( m + "Value high warn = " + getValueWarnHigh());
       System.out.println( m + "Value low warn = " + getValueWarnLow());       
       System.out.println( m + "Code = " + getCode());       
       System.out.println( m + "Code High = " + getCodeHigh());       
       System.out.println( m + "Code Low = " + getCodeLow());       
    }

    void parse(Element root)
    {
        NodeList children = root.getChildNodes();
        for (int i = 0; i < children.getLength(); i++)
        {
            Node child = children.item(i);
            if (child instanceof Element)
            {
                Element childElement = (Element) child;
                Text textNode = (Text) childElement.getFirstChild();
                if( textNode == null ) continue;
                String text = textNode.getData().trim();
                if(childElement.getTagName().equalsIgnoreCase("DEVICE_NAME"))
                {
                    setDeviceName(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("SEVERITY"))
                {
                    setSeverity(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("SEVERITY_HIGH"))
                {
                    setSeverityHigh(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("SEVERITY_LOW"))
                {
                    setSeverityLow(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("SEVERITY_HIGH_WARN"))
                {
                    setSeverityWarnHigh(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("SEVERITY_LOW_WARN"))
                {
                    setSeverityWarnLow(ValidatedInt.parse(text));
                }  
                else if(childElement.getTagName().equalsIgnoreCase("SYSTEM"))
                {
                    setSystem(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("VALUE_MASK"))
                {
                    setValueMask(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("VALUE_NORMAL"))
                {
                  String vtext;
                  if (text.startsWith("!"))
                  {
                    vtext = text.substring(1);
                    normalIsAlarm = true;
                  }
                  else
                  {
                    vtext = text;
                  }
                  setValueNormal(ValidatedInt.parse(vtext));
                }                
                else if(childElement.getTagName().equalsIgnoreCase("COUNT_THRESHOLD"))
                {
                    setCountThreshold(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("VALUE_HIGH"))
                {
                    setValueHigh(ValidatedFloat.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("VALUE_LOW"))
                {
                    setValueLow(ValidatedFloat.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("VALUE_HIGH_WARN"))
                {
                    setValueWarnHigh(ValidatedFloat.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("VALUE_LOW_WARN"))
                {
                    setValueWarnLow(ValidatedFloat.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ALARM_CODE"))
                {
                    setCode(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ALARM_CODE_HIGH"))
                {
                    setCodeHigh(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ALARM_CODE_LOW"))
                {
                    setCodeLow(ValidatedInt.parse(text));
                }
                else System.out.println("-WARNING: unsupported tag: " + childElement.getTagName());
            }                
        }   
    }

    public ValidatedInt getSeverity()
    {
      return severity;
    }

    public void setSeverity(ValidatedInt severity)
    {
      this.severity = severity;
    }

    public ValidatedInt getCode()
    {
      return code;
    }

    public ValidatedInt getCodeHigh()
    {
      return codeHigh;
    }

    public ValidatedInt getCodeLow()
    {
      return codeLow;
    }

    public void setCode(ValidatedInt code)
    {
      this.code = code;
    }

    public void setCodeHigh(ValidatedInt codeHigh)
    {
      this.codeHigh = codeHigh;
    }

    public void setCodeLow(ValidatedInt codeLow)
    {
      this.codeLow = codeLow;
    }    
}
